QGIS Application - Bug report #16869

SelectTool on Oracle layer selects always ALL features

2017-07-14 04:26 PM - Richard Duivenvoorde

Status: Closed

Priority: High

Assignee:

Category: Data Provider/Oracle

Affected QGIS version:master
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: Yes
Easy fix?: No
Resolution: fixed/implemented

Copied to github as #: 24768

Description

In latest master, loading an Oracle layer and trying to select a couple of features with the selectTool, ALL features are selected (or at

least turn yellow).

Same machine, same layer/db, but with 2.18.10 this is ok.

Selecttool is also working OK if | select a postgis layer on that same machine/QGIS. So to me it seems Oracle provider related.

Associated revisions

Revision 7ffc148e - 2018-03-06 12:27 AM - Nyall Dawson

[oracle] Fix provider

The oracle provider is quite broken on 3.0 for tables which require
a feature id map.

This is due to QMap<QVariant,..> not working correctly when the
keys are QVariantLists on Qt5. We had a similar issue with the
postgres provider which was resolved by changing the map

to always use QVariantLists.

Apply the same fix to oracle.

Fixes #18289, #16869, #17738

Revision 5234212e - 2018-03-06 02:20 AM - Nyall Dawson

[oracle] Fix provider

The oracle provider is quite broken on 3.0 for tables which require
a feature id map.

This is due to QMap<QVariant,..> not working correctly when the
keys are QVariantLists on Qt5. We had a similar issue with the
postgres provider which was resolved by changing the map

to always use QVariantLists.

Apply the same fix to oracle.
Fixes #18289, #16869, #17738

(cherry-picked from 7ffc148)

History

#1 - 2017-07-14 04:30 PM - Jiirgen Fischer

Which primary key does the table have?

#2 - 2017-07-14 04:42 PM - Richard Duivenvoorde

- File nokey.png added

Well, apparently none when | look into the 'open layer' dialog (see screendump).

And looking into the DDL of the table, there is NOT a primary key on one of the columns...

And trying to create a primary key, | fail because some rows have null values for fields...

Is a primary key always needed? 2.18.10 seems to work without it?

#3 - 2017-07-14 04:53 PM - Richard Duivenvoorde

Additional observation (but probably same reason): no rows are shown in attribute table.

In case of such a table, QGIS can apparently load and show the features. Should/Could we maybe generate an internal id for these?

#4 - 2017-09-08 01:35 PM - Juirgen Fischer

- Assignee deleted (Jiirgen Fischer)

#5 - 2018-02-22 07:44 PM - Giovanni Manghi
- Priority changed from Normal to High

#6 - 2018-03-06 12:27 AM - Nyall Dawson

- Status changed from Open to Closed
- % Done changed from 0 to 100

Applied in changeset commit:qgis|7ffc148e356ef251e93502e3c965bf912592eda?2.

#7 - 2018-03-06 09:52 AM - Giovanni Manghi

- Resolution set to fixed/implemented

Files

nokey.png 26.1 KB 2017-07-14 Richard Duivenvoorde
